/*
 * MenuJuego.cpp
 *
 *  Created on: 26/06/2011
 *      Author: antonio
 */

#include <sstream>
#include <iostream>
#include <math.h>
#include "MenuJuego.h"

using namespace STDP;

MenuJuego::MenuJuego(StdPijo& stdp) {
	minas = tiempoJuego = nivel = puntos =0;
	numMensajes=2; //Establecemos el número de mensajes destructivos
	this->stdp=&stdp;
}

MenuJuego::~MenuJuego() {
	// TODO Auto-generated destructor stub
}

void MenuJuego::imprimirMenuJuegoStandard()
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 1, CGREEN, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 3, CGREEN, ABOLD);

	stringstream nivel;
	nivel << "Nivel: " << this->nivel;
	imprimirTextoCentrado(nivel.str(), 5, CGREEN, ABOLD);

	stringstream puntos;
	puntos << "Puntos: " << this->puntos;
	imprimirTextoCentrado(puntos.str(), 6, CGREEN, ABOLD);

}

void MenuJuego::imprimirTextoCentrado(string texto, int fila, Color color, Attribute atributo)
{
	int espacio = margenDer-margenIzq;
	espacio -= texto.length();
	espacio /= 2;
	stdp->setCursor(espacio+margenIzq, fila);

	stdp->setColor(atributo, color, CBLACK);
	stdp->writeStr(texto.c_str());
}

void MenuJuego::mostrarFalloStandard()
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 1, CGREEN, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 3, CGREEN, ABOLD);

	stringstream nivel;
	nivel << "Nivel: " << this->nivel;
	imprimirTextoCentrado(nivel.str(), 5, CGREEN, ABOLD);

	stringstream puntos;
	puntos << "Puntos: " << this->puntos;
	imprimirTextoCentrado(puntos.str(), 6, CGREEN, ABOLD);


	imprimirTextoCentrado(mensajeDesolador(), 10, CWHITE, ABOLD);
	imprimirTextoCentrado("Pulse espacio para repetir", 11, CWHITE, ANORMAL);
	imprimirTextoCentrado("o 'Esc' para continuar", 12, CWHITE, ANORMAL);
}

string MenuJuego::mensajeDesolador()
{
	string mensajes[numMensajes];
	mensajes[0] = "En que carajo pensabas??";
	mensajes[1] = "Tienes algo en el ojo?";

	return mensajes[this->nivel%numMensajes];
}

void MenuJuego::imprimirMenuJuegoHistoria(Color marcador)
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 3, marcador, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 5, marcador, ABOLD);

	stringstream nivel;
	nivel << "Capítulo : " << this->nivel;
	imprimirTextoCentrado(nivel.str(), 7, marcador, ABOLD);

	stringstream puntos;
	puntos << "Puntos: " << this->puntos;
	imprimirTextoCentrado(puntos.str(), 8, marcador, ABOLD);
}

void MenuJuego::mostrarFinalPartidaHistoria(Color marcador)
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 3, marcador, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 5, marcador, ABOLD);

	stringstream nivel;
	nivel << "Capítulo : " << this->nivel;
	imprimirTextoCentrado(nivel.str(), 7, marcador, ABOLD);

	stringstream puntos;
	puntos << "Puntos: " << this->puntos;
	imprimirTextoCentrado(puntos.str(), 8, marcador, ABOLD);

	imprimirTextoCentrado("Nivel superado!!!", 10, CWHITE, ABOLD);
	imprimirTextoCentrado("Pulse espacio para continuar", 11, CWHITE, ANORMAL);
	imprimirTextoCentrado("o 'Esc' para salir", 12, CWHITE, ANORMAL);
}

void MenuJuego::mostrarFalloHistoria(Color marcador)
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 3, marcador, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 5, marcador, ABOLD);

	stringstream nivel;
	nivel << "Capítulo : " << this->nivel;
	imprimirTextoCentrado(nivel.str(), 7, marcador, ABOLD);

	stringstream puntos;
	puntos << "Puntos: " << this->puntos;
	imprimirTextoCentrado(puntos.str(), 8, marcador, ABOLD);

	imprimirTextoCentrado(mensajeDesolador(), 10, CWHITE, ABOLD);
	imprimirTextoCentrado("Pulse espacio para repetir", 11, CWHITE, ANORMAL);
	imprimirTextoCentrado("o 'Esc' para continuar", 12, CWHITE, ANORMAL);
}

void MenuJuego::imprimirMenuJuegoSupervivencia()
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 4, CGREEN, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 6, CGREEN, ABOLD);
}

void MenuJuego::mostrarFalloSupervivencia()
{
	imprimirMenuJuegoSupervivencia();

	imprimirTextoCentrado(mensajeDesolador(), 10, CWHITE, ABOLD);
	imprimirTextoCentrado("Pulse espacio para repetir", 11, CWHITE, ANORMAL);
	imprimirTextoCentrado("o 'Esc' para continuar", 12, CWHITE, ANORMAL);
}

void MenuJuego::mostrarFinalPartidaSupervivencia()
{
	imprimirMenuJuegoSupervivencia();

	imprimirTextoCentrado("A ver si puedes con el siguiente", 10, CWHITE, ABOLD);
	imprimirTextoCentrado("Pulse espacio para continuar", 11, CWHITE, ANORMAL);
	imprimirTextoCentrado("o 'Esc' para salir", 12, CWHITE, ANORMAL);
}

void MenuJuego::imprimirCharCentrado(char texto, int fila, Color color, Attribute atributo)
{
	int espacio = margenDer-margenIzq;
	espacio -= 1;
	espacio /= 2;
	stdp->setCursor(espacio+margenIzq, fila);

	stdp->setColor(atributo, color, CBLACK);
	stdp->writeChar(texto);
}

void MenuJuego::mostrarFinalPartidaStandard()
{
	stringstream minas;
	minas << "Minas: " << this->minas;
	imprimirTextoCentrado(minas.str(), 1, CGREEN, ABOLD);

	stringstream tiempo;
	tiempoJuego=((double)((int)(tiempoJuego*100+0.5)))/100;
	tiempo << "Tiempo de juego: " << tiempoJuego;
	imprimirTextoCentrado(tiempo.str(), 3, CGREEN, ABOLD);

	stringstream nivel;
	nivel << "Nivel: " << this->nivel;
	imprimirTextoCentrado(nivel.str(), 5, CGREEN, ABOLD);

	stringstream puntos;
	puntos << "Puntos: " << this->puntos;
	imprimirTextoCentrado(puntos.str(), 6, CGREEN, ABOLD);

	imprimirTextoCentrado("Nivel superado!!!", 10, CWHITE, ABOLD);
	imprimirTextoCentrado("Pulse espacio para continuar", 11, CWHITE, ANORMAL);
	imprimirTextoCentrado("o 'Esc' para salir", 12, CWHITE, ANORMAL);
}





